_layer_dialogs = {}


def add_layer_dialog(type, layer_class, dialog_class):
    try:
        _layer_dialogs[type].append((layer_class, dialog_class))
    except KeyError:
        _layer_dialogs[type] = [(layer_class, dialog_class)]
    

def init_layer_dialogs(type):
    try:
        del _layer_dialogs[type][:]
    except KeyError:
        pass


def has_layer_dialog(type, layer_class):
    for cls, dialog_class in _layer_dialogs[type]:
        if cls == layer_class:
            return True
    return False


def get_layer_dialog_class(type, layer):
    for layer_class, dialog_class in _layer_dialogs['properties']:
        if isinstance(layer, layer_class):
            return dialog_class
    return None


def get_layer_properties_class(layer):
    return get_layer_dialog_class('properties', layer)
